<?php
namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00006001TabelaPrecoServicoFactory;
use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;
use Teknisa\SM\Util\Procedure\FctSincronizarVariacaoPreco;

class Sm00006001TabelaPrecoServicoService
{
    
    protected $FactoryTabPrecoServico;
    protected $Environment;
    protected $connection;
    
    public function __construct (Sm00006001TabelaPrecoServicoFactory $FactoryTabPrecoServico, Environment $Environment, EntityManager $entityManager){
        
        $this->FactoryTabPrecoServico  = $FactoryTabPrecoServico;
        $this->Environment  = $Environment;
        $this->connection = $entityManager->getConnection();

    }
    
    /**
     * A função "validaServicoTabela" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço.
     */
     
    public function validaServicoTabela($servOrca, $precBaseServ, $tipoMedida){
    
        $params = array(
            "CDSERVORCA"  => implode(',', $servOrca),
            "CDPRECBASESERV"       => $precBaseServ,
            "CDTPMEDIDASERV"   => $tipoMedida,
            "NRORG"            => $this->Environment->getNrOrg()
        );
        
        $return = $this->FactoryTabPrecoServico->validaServicoTabela($params);
        
        return $return[0]["VALIDASERV"] != 0;
        
    }
    
     /**
     * A função "executarProcedureFctSincronizarVariacaoPreco" executa a procedure
     * "FCT_SINCRONIZAR_VARIACAO_PRECO".
     */
    
    public function executarProcedureFctSincronizarVariacaoPreco($itPrecBaseServ, $tipo, $nrorg, $operador) {
        $procedure = new FctSincronizarVariacaoPreco($this->connection);
        $procedure->executar($itPrecBaseServ, $tipo, $nrorg, $operador);
    }

}
?>